from pprint import pprint

from local_push import forward_local_push, update_forward_push_multi, edge_deletion_multiple, edge_addition_multiple, \
    update_graph_mix

def checker_add(double alpha, double epsilon, explanation, g, replacing_item, source_node, target_nodes, pf=None,
                rf=None,
                bint debug=False):
    cdef int index_replacement
    if debug:
        print('============ Checking ============')
        print("explanations => ")
        pprint(explanation)

    target_nodes_new = target_nodes.copy()
    [target_nodes_new.remove(e[1]) for e in explanation if e[1] in target_nodes_new]
    neighbors = [e[1] for e in explanation]

    if pf and rf:
        p, r = update_forward_push_multi(g.copy(), source_node, neighbors, pf, rf, alpha, epsilon, action="a")
    else:
        edge_addition_multiple(g, source_node, neighbors)
        p, r = forward_local_push(g.copy(), source_node, {}, {}, alpha=alpha, e=epsilon)

    tmp_proba = {key: p[key] for key in p if key in target_nodes_new}
    if debug:
        pprint([("ppr(%s,%s) -> %s" % (source_node, v, tmp_proba[v])) for v in sorted(tmp_proba, key=tmp_proba.get)])

    if len(tmp_proba) == 0:
        if debug:
            print("no results ...\n")
        return False, [], None
    top_node = max(tmp_proba, key=tmp_proba.get)
    tmp_proba = sorted(tmp_proba, key=tmp_proba.get)

    if top_node != replacing_item:
        # if abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) + 1]]) < 2 * epsilon:
        #     if debug:
        #         print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
        #             source_node, replacing_item, source_node, tmp_proba.index(replacing_item) + 1,
        #             abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) + 1]]),
        #             2 * epsilon))
        #         print("epsilon too small ! ")
        #     return False, [], None
        # if abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]) < 2 * epsilon:
        #     if debug:
        #         print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
        #             source_node, replacing_item, source_node, tmp_proba.index(replacing_item) - 1,
        #             abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]),
        #             2 * epsilon))
        #         print("epsilon too small ! ")
        #     return False, [], None

        # if not result:
        if replacing_item in tmp_proba:
            index_replacement = tmp_proba.index(replacing_item) + 1
        else:
            index_replacement = -1

        better_option = tmp_proba[index_replacement:]
        if debug:
            print("not the same results ...\n")
            print("top node %s\n" % top_node)
            print("expected %s\n" % replacing_item)
            print("better items are  %s\n" % better_option)

        return False, better_option, index_replacement
    else:
        if abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]) < 2 * epsilon:
            if debug:
                print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
                    source_node, replacing_item, source_node, tmp_proba.index(replacing_item) - 1,
                    abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]),
                    2 * epsilon))
                print("epsilon too small ! ")
            return False, [], None

        else:
            if debug:
                print("works ! ")
                print("top node %s\n" % top_node)
                print("expected %s\n" % replacing_item)
            return True, top_node, 0

def checker_remove(double alpha, double epsilon, explanation, g, replacing_item, source_node, target_nodes,
                   bint debug=False, pf=None,
                   rf=None):
    cdef int index_replacement
    if debug:
        print('============ Checking ============')
        print("explanations => ")
        pprint(explanation)

    neighbors = [e[1] for e in explanation]
    # if pf and rf:
    #     p, r = update_forward_push_multi(g.copy(), source_node, neighbors, pf.copy(), rf.copy(), alpha, epsilon,
    #                                      action="d")
    # else:
    tmp_g = g.copy()
    edge_deletion_multiple(tmp_g, source_node, neighbors)
    p, r = forward_local_push(tmp_g, source_node, {}, {}, alpha=alpha, e=epsilon)

    tmp_proba = {key: p[key] for key in p if key in target_nodes}
    if debug:
        if len(tmp_proba) > 0:
            pprint(
                [("ppr(%s,%s) -> %s" % (source_node, v, tmp_proba[v])) for v in sorted(tmp_proba, key=tmp_proba.get)])

    if len(tmp_proba) == 0:
        if debug:
            print("no results ...\n")
        return False, [], None

    tmp_proba = sorted(tmp_proba, key=tmp_proba.get)
    top_node = tmp_proba[-1]
    if top_node != replacing_item:
        # if abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) + 1]]) < 2 * epsilon:
        #     if debug:
        #         print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
        #             source_node, replacing_item, source_node, tmp_proba.index(replacing_item) + 1,
        #             abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) + 1]]),
        #             2 * epsilon))
        #         print("epsilon too small ! ")
        #     return False, [], None
        # if abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]) < 2 * epsilon:
        #     if debug:
        #         print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
        #             source_node, replacing_item, source_node, tmp_proba.index(replacing_item) - 1,
        #             abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]),
        #             2 * epsilon))
        #         print("epsilon too small ! ")
        #     return False, [], None

        if replacing_item in tmp_proba:
            index_replacement = tmp_proba.index(replacing_item) + 1
        else:
            index_replacement = -1

        # if not result:
        better_options = tmp_proba[index_replacement:]
        if debug:
            print("not the same results ...\n")
            print("top node %s\n" % top_node)
            print("expected %s\n" % replacing_item)
            print("better items are  %s\n" % better_options)

        return False, better_options, index_replacement
    else:
        if (abs(p[replacing_item] - p.get(tmp_proba[tmp_proba.index(replacing_item) - 1], 0)) < 2 * epsilon):
            if debug:
                print("abs(ppr(%s,%s)  -  ppr(%s,%s) )  = %s < 2*epsilon =  %s" % (
                    source_node, replacing_item, source_node, tmp_proba.index(replacing_item) - 1,
                    abs(p[replacing_item] - p[tmp_proba[tmp_proba.index(replacing_item) - 1]]),
                    2 * epsilon))
                print("epsilon too small ! ")
            return False, [], None

        else:
            if debug:
                print("works ! ")
                print("top node %s\n" % top_node)
                print("expected %s\n" % replacing_item)
            return True, top_node, 0

def checker_mix(double alpha, double epsilon, explanation, g, replacing_item, source_node, target_nodes,
                bint debug=False,
                pf=None, rf=None):
    cdef int index_replacement
    if debug:
        print('============ Checking ============')
        print("explanations => ")
        pprint(explanation)

    target_nodes_new = target_nodes.copy()
    removed_neighbors = [e[1] for e in explanation if e[2] == "-"]
    added_neighbors = [e[1] for e in explanation if e[2] == "+"]

    [target_nodes_new.remove(e[1]) for e in explanation if e[1] in target_nodes_new]

    g, p, r = update_graph_mix(g, source_node, removed_neighbors, added_neighbors, alpha, epsilon, pf, rf)

    tmp_proba = {key: p[key] for key in p if key in target_nodes_new}
    if debug:
        if len(tmp_proba) > 0:
            pprint(
                [("ppr(%s,%s) -> %s" % (source_node, v, tmp_proba[v])) for v in sorted(tmp_proba, key=tmp_proba.get)])
        else:
            pprint([("ppr(%s,%s) -> %s" % (source_node, v, p[v])) for v in sorted(p, key=p.get)])

    if len(tmp_proba) == 0:
        if debug:
            print("no results ...\n")
        return False, [], None
    top_node = max(tmp_proba, key=tmp_proba.get)
    tmp_proba = sorted(tmp_proba, key=tmp_proba.get)

    if top_node != replacing_item:
        if replacing_item in tmp_proba:
            index_replacement = tmp_proba.index(replacing_item) + 1
        else:
            index_replacement = -1

        # if not result:
        better_options = tmp_proba[:index_replacement]
        if debug:
            print("not the same results ...\n")
            print("top node %s\n" % top_node)
            print("expected %s\n" % replacing_item)
            print("better items are  %s\n" % better_options)

        return False, better_options, index_replacement
    else:
        if debug:
            print("works ! ")
            print("top node %s\n" % top_node)
            print("expected %s\n" % replacing_item)
        return True, top_node, 0