from pprint import pprint

from local_push import forward_local_push
from swapOrder import swapOrderWhy, swapOrder_whynot_remove_incremental, swapOrder_why_not_add_incremental, \
    swapOrder_whynot_remove_powerset, \
    swapOrder_whynot_brute_force, swapOrder_why_not_add_powerset, swapOrder_whynot_remove_exhaustive, \
    swapOrder_whynot_add_exhaustive

def why(g, source_node, target_nodes, top_node=None, epsilon=0.00005, topk=5, pf=None, rf = None, debug=False):
    if debug:
        print('============ why ============')
        print("neighbors :%s" % list(g.neighbors(source_node)))
    alpha = 0.15

    # try:
    #     p, r = g.nodes[source_node]['p'], g.nodes[source_node]['r']
    # except exception as e:
    #     # print(e)
    if not (top_node and pf and rf):
        try:
            pf, rf = g.nodes[source_node]['p'], g.nodes[source_node]['r']
        except Exception as e:
            top_list, pf, rf = top_items(g, source_node, target_nodes, epsilon, alpha, topk, debug=debug)
            g.nodes[source_node]['p'] = pf
            g.nodes[source_node]['r'] = rf
            top_node = top_list[-1]
        tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
        while len(tmp_proba) == 0 and epsilon > 0.00001:
            epsilon *= 0.1
            pf, rf = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
            tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
            if debug:
                print("epsilon %s" % epsilon)

        top_node = max(tmp_proba, key=tmp_proba.get)

    if debug:
        print('Top item:', top_node)
    replacing_item = top_node
    explanation = list(g.edges(source_node))

    exp_list = []
    tt = target_nodes
    tt.remove(top_node)
    for candidate_node in (tt):
        if debug:
            print("candidate node : %s" % candidate_node)
        tmp_g, tmp_explanation = swapOrderWhy(g.copy(), source_node, top_node, candidate_node, epsilon, alpha,
                                              pf, rf, debug)
        p, r = forward_local_push(tmp_g, source_node, {}, {}, alpha=alpha, e=epsilon)
        if debug:
            print("candidate explanation: %s" % tmp_explanation)

        exp_list.append([candidate_node, tmp_explanation, ("rec = %s" % p.get(top_node, 0)),
                         ("rec* = %s" % p.get(candidate_node, 0))])

        if len(tmp_explanation) > 0:
            if len(tmp_explanation) < len(explanation):
                if debug:
                    print("old replacement item: %s" % replacing_item)
                    print("old explanation: %s" % explanation)
                replacing_item = candidate_node
                explanation = tmp_explanation
                if debug:
                    print("new replacement item: %s" % replacing_item)
                    print("new explanation: %s" % explanation)

            elif len(tmp_explanation) == len(explanation):
                if debug:
                    print("ppr  p.get(candidate_node, 0) : %s   p.get(replacing_item, 0) :  %s " % (
                        p.get(candidate_node, 0), p.get(replacing_item, 0)))

                if p.get(candidate_node, 0) > p.get(replacing_item, 0):
                    if debug:
                        print("old replacement item: %s" % replacing_item)
                        print("old explanation: %s" % explanation)
                    replacing_item = candidate_node
                    explanation = tmp_explanation
                    if debug:
                        print("new replacement item: %s" % replacing_item)
                        print("new explanation: %s" % explanation)

    if replacing_item == top_node:
        replacing_item = None
        explanation = []

    g.nodes[source_node]['explanation'] = explanation
    g.nodes[source_node]['top_node'] = top_node
    g.nodes[source_node]['replacing_item'] = replacing_item

    return alpha, epsilon, explanation, g, replacing_item

def why_not_remove(g, source_node, target_nodes, why_not_node, mode="incremental", epsilon=None, top_node=None,
                   debug=False,
                   pf=None,
                   rf=None, pr=None, rr=None, p=None, r=None):
    if debug:
        print('============ WHY NOT REMOVE ============')
    cdef double alpha = 0.15
    if mode == "brute":
        tmp_g, explanation = swapOrder_whynot_brute_force(g, source_node, top_node, why_not_node, target_nodes, epsilon,
                                                          alpha, debug=debug)
    # tuning graph into a weighted one
    else:
        if not (top_node and pf and rf):
            try:
                pf, rf = g.nodes[source_node]['p'], g.nodes[source_node]['r']
            except:
                pf, rf = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
            tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
            while len(tmp_proba) == 0 and epsilon > 0.00001:
                epsilon *= 0.1
                pf, rf = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
                tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
                if debug:
                    print("epsilon %s" % epsilon)

            top_node = max(tmp_proba, key=tmp_proba.get)

        # try:
        #     _, _ = g.nodes[source_node]['p_no_u'], g.nodes[source_node]['r_no_u']
        # except:
        #     pr[why_not_node], rr[why_not_node] = reverse_local_push(g, why_not_node, {}, {}, alpha=alpha, e=epsilon)
        #     pr[top_node], rr[top_node] = reverse_local_push(g, top_node, {}, {}, alpha=alpha, e=epsilon)
        if debug:
            print('Top item:', top_node)
        new_g = g.copy()
        if mode == "incremental":
            tmp_g, explanation = swapOrder_whynot_remove_incremental(g, source_node, top_node, why_not_node,
                                                                     target_nodes, epsilon,
                                                                     alpha, pf.copy(), rf.copy(), debug=debug)

        elif mode == "exhaustive":
            tmp_g, explanation = swapOrder_whynot_remove_exhaustive(g, source_node, top_node, why_not_node,
                                                                    target_nodes,
                                                                    epsilon, alpha, pf.copy(), rf.copy(), debug=debug)


        elif mode == "powerset":
            tmp_g, explanation = swapOrder_whynot_remove_powerset(g, source_node, top_node, why_not_node,
                                                                  target_nodes,
                                                                  epsilon,
                                                                  alpha, pf.copy(), rf.copy(), debug=debug)

    tmp_g.nodes[source_node]['explanation'] = explanation
    tmp_g.nodes[source_node]['top_node'] = top_node
    tmp_g.nodes[source_node]['replacing_item'] = why_not_node
    if debug:
        print("removing %s , change %s to %s" % (explanation, top_node, why_not_node),)
    return alpha, epsilon, explanation, tmp_g

def why_not_add(g, source_node, target_nodes, why_not_node, epsilon=None, top_node=None, debug=False, pf=None, rf=None,
                mode="incremental"):
    if debug:
        print('============ WHY NOT ADD============')

    # tuning graph into a weighted one
    alpha = 0.15
    if not (top_node and pf and rf):
        try:
            pf, rf = g.nodes[source_node]['p'], g.nodes[source_node]['r']
        except:
            pf, rf = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
        tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
        # if the epsilon is too big we correct it
        while len(tmp_proba) == 0 and epsilon > 0.00001:
            epsilon *= 0.1
            pf, rf = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
            tmp_proba = {key: pf[key] for key in pf if key in target_nodes}
            if debug:
                print("epsilon %s" % epsilon)

        top_node = max(tmp_proba, key=tmp_proba.get)
    if debug:
        print('Top item:', top_node)

    if mode == "incremental":
        tmp_g, explanation = swapOrder_why_not_add_incremental(g, source_node=source_node, top_node=top_node,
                                                               replacement=why_not_node,
                                                               target_nodes=target_nodes, epsilon=epsilon, alpha=alpha,
                                                               pf=pf.copy(),
                                                               rf=rf.copy(), debug=debug)
    elif mode == "powerset":
        tmp_g, explanation = swapOrder_why_not_add_powerset(g, source_node=source_node, top_node=top_node,
                                                            replacement=why_not_node,
                                                            target_nodes=target_nodes, epsilon=epsilon, alpha=alpha,
                                                            pf=pf.copy(),
                                                            rf=rf.copy(), debug=debug)
    elif mode == "exhaustive":
        tmp_g, explanation = swapOrder_whynot_add_exhaustive(g, source_node=source_node, top_node=top_node,
                                                             replacement=why_not_node,
                                                             target_nodes=target_nodes, epsilon=epsilon, alpha=alpha,
                                                             pf=pf.copy(),
                                                             rf=rf.copy(), debug=debug)

    tmp_g.nodes[source_node]['explanation'] = explanation
    tmp_g.nodes[source_node]['top_node'] = top_node
    tmp_g.nodes[source_node]['replacing_item'] = why_not_node
    if debug:
        print("adding %s , change %s to %s" % (explanation, top_node, why_not_node),)
    return alpha, epsilon, explanation, tmp_g

def top_items(g, source_node, target_nodes, epsilon=0.00005, alpha=0.15, topk=None, debug=False):
    '''
    Compute the ppr and sort the target item by the ppr.
    The first item is then the recomendation
    :param topk:
    :param g: networkx graph
    :param source_node: source user node
    :param target_nodes: llist of item to consider as possible recommendation
    :param epsilon: ppr parameter
    :param alpha: ppr parameter
    :param topk: length of the recommendation list
    :param debug: enable output of debug information
    :return:
    '''
    if debug:
        print('============ providing recommendations ============')
    try:
        p, r = g.nodes[source_node]['p'], g.nodes[source_node]['r']
    except Exception as e:
        p, r = forward_local_push(g, source_node, {}, {}, alpha=alpha, e=epsilon)
        g.nodes[source_node]['p'] = p
        g.nodes[source_node]['r'] = r
    top_list = {key: p[key] for key in p if key in target_nodes}

    if debug:
        print("target items :")
        pprint([("ppr(%s,%s) -> %s" % (source_node, v, top_list[v])) for v in sorted(top_list, key=top_list.get)])
    if topk is not None:
        top_list = sorted(top_list, key=top_list.get)[-min(topk, len(top_list)):]

    return top_list, p, r